	/* Programma OMICIDIO */
	
DOMAINS
  nome,sesso,professione,oggetto,cosa = symbol
  eta = integer
PREDICATES
  persona(nome,eta,sesso,professione)
  conosceva(nome,nome)
  assassinata_con(nome,oggetto)
  motivo(cosa)
  sporcato_di(nome,cosa)
  possiede(nome,oggetto)
  forse_possiede(nome,oggetto)
  ha_lo_stesso_effetto(oggetto,oggetto)
  sospetto(nome)
CLAUSES
  persona(allan,  25,m,calciatore).
  persona(allan,  25,m,macellaio).
  persona(barbara,22,f,parrucchiera).
  persona(bert,   55,m,carpentiere).
  persona(john,   25,m,ladro).
  
  conosceva(barbara,john).
  conosceva(barbara,bert).
  conosceva(susan  ,john).
  
  assassinata_con(susan,mazza).
  
  motivo(denaro).
  motivo(gelosia).
  
  sporcato_di(catherine,sangue).
  sporcato_di(allan    ,fango).
  
  possiede(bert,gamba_di_legno).
  possiede(john,pistola).
  
/* Altri fatti noti */
  ha_lo_stesso_effetto(gamba_di_legno,mazza).
  ha_lo_stesso_effetto(barra,mazza).
  ha_lo_stesso_effetto(forbici,coltello).
  ha_lo_stesso_effetto(scarpa_di_calcio,mazza).
  
  forse_possiede(X,scarpa_di_calcio) :- persona(X,_,_,calciatore).
  forse_possiede(X,forbici)	     :- persona(X,_,_,_).
  forse_possiede(X,Oggetto)	     :- possiede(X,Oggetto).
  
/* Sono sospetti tutti quelli che possiedono un'arma simile a quella con cui SUSAN potrebbe essere stata assassinata */
  sospetto(X) :- assassinata_con(susan,Arma),
  		 ha_lo_stesso_effetto(Oggetto,Arma),
  		 forse_possiede(X,Oggetto).
  		 
/* Sono sospetti gli uomini che conoscevano SUSAN */
  sospetto(X) :- motivo(gelosia),
  		 persona(X,_,m,_),
  		 conosceva(susan,X).
  		 
/* Sono sospette le donne che conoscevano un uomo che SUSAN conosceva */
  sospetto(X) :- motivo(gelosia),
  		 persona(X,_,f,_),
  		 conosceva(X,Uomo),
  		 conosceva(susan,Uomo).
  		 
/* Sono sospetti i ladri, il cui motivo potrebbe essere il denaro */
  sospetto(X) :- motivo(denaro),
  		 persona(X,_,_,ladro).
  		 